Index: /trunk/src/VBox/Frontends/VirtualBox/include/VBoxUtils-darwin.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/include/VBoxUtils-darwin.h	(revision 17149)
+++ /trunk/src/VBox/Frontends/VirtualBox/include/VBoxUtils-darwin.h	(revision 17150)
@@ -72,4 +72,6 @@
  ********************************************************************************/
 void darwinSetShowsToolbarButtonImpl (NativeWindowRef aWindow, bool aEnabled);
+void darwinSetShowsResizeIndicatorImpl (NativeWindowRef aWindow, bool aEnabled);
+void darwinSetHidesAllTitleButtonsImpl (NativeWindowRef aWindow);
 void darwinSetMouseCoalescingEnabled (bool aEnabled);
 
@@ -123,4 +125,6 @@
  ********************************************************************************/
 void darwinSetShowsToolbarButton (QToolBar *aToolBar, bool aEnabled);
+void darwinSetShowsResizeIndicator (QWidget *aWidget, bool aEnabled);
+void darwinSetHidesAllTitleButtons (QWidget *aWidget);
 void darwinDisableIconsInMenus (void);
 
@@ -130,7 +134,7 @@
  *
  ********************************************************************************/
+void darwinWindowAnimateResize (QWidget *aWidget, const QRect &aTarget);
 QString darwinSystemLanguage (void);
 QPixmap darwinCreateDragPixmap (const QPixmap& aPixmap, const QString &aText);
-void darwinWindowAnimateResize (QWidget *aWidget, const QRect &aTarget);
 
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/QIDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/QIDialog.cpp	(revision 17149)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/QIDialog.cpp	(revision 17150)
@@ -47,9 +47,5 @@
         setFixedSize (size());
 #ifdef Q_WS_MAC
-# ifdef QT_MAC_USE_COCOA
-        /** @todo Carbon -> Cocoa */
-# else
-        ChangeWindowAttributes (::darwinToNativeWindow (this), kWindowNoAttributes, kWindowResizableAttribute);
-# endif
+        ::darwinSetShowsResizeIndicator (this, false);
 #endif /* Q_WS_MAC */
     }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSettingsDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSettingsDialog.cpp	(revision 17149)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/VBoxSettingsDialog.cpp	(revision 17150)
@@ -299,4 +299,5 @@
         setFixedSize (ss);
     }
+    ::darwinSetShowsResizeIndicator (this, false);
 #endif /* !Q_WS_MAC */
 # ifdef VBOX_GUI_WITH_TOOLBAR_SETTINGS
@@ -414,4 +415,7 @@
     int minWidth = mSelector->minWidth();
 #ifdef Q_WS_MAC
+    /* Remove all title bar buttons (Buggy Qt) */
+    ::darwinSetHidesAllTitleButtons (this);
+
     /* Set all size policies to ignored */
     for (int i = 0; i < mStack->count(); ++i)
Index: /trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin-carbon.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin-carbon.cpp	(revision 17149)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin-carbon.cpp	(revision 17150)
@@ -30,11 +30,20 @@
 NativeWindowRef darwinToNativeWindowImpl (NativeViewRef aView)
 {
-    return reinterpret_cast<WindowRef> (::HIViewGetWindow (aView));
+    if (aView)
+        return reinterpret_cast<WindowRef> (::HIViewGetWindow (aView));
+    return NULL;
 }
 
 void darwinSetShowsToolbarButtonImpl (NativeWindowRef aWindow, bool aEnabled)
 {
-    int err = ::ChangeWindowAttributes (aWindow, aEnabled ? kWindowToolbarButtonAttribute:kWindowNoAttributes,
-                                                 aEnabled ? kWindowNoAttributes:kWindowToolbarButtonAttribute);
+    int err = ::ChangeWindowAttributes (aWindow, aEnabled ? kWindowToolbarButtonAttribute : kWindowNoAttributes,
+                                                 aEnabled ? kWindowNoAttributes : kWindowToolbarButtonAttribute);
+    AssertCarbonOSStatus (err);
+}
+
+void darwinSetShowsResizeIndicatorImpl (NativeWindowRef aWindow, bool aEnabled)
+{
+    int err = ::ChangeWindowAttributes (aWindow, aEnabled ? kWindowResizableAttribute : kWindowNoAttributes,
+                                                 aEnabled ? kWindowNoAttributes : kWindowResizableAttribute);
     AssertCarbonOSStatus (err);
 }
@@ -42,5 +51,6 @@
 void darwinSetMouseCoalescingEnabled (bool aEnabled)
 {
-    ::SetMouseCoalescingEnabled (aEnabled, NULL);
+    int err = ::SetMouseCoalescingEnabled (aEnabled, NULL);
+    AssertCarbonOSStatus (err);
 }
 
@@ -48,7 +58,12 @@
 {
     HIRect r = CGRectMake (x, y, width, height);
-    TransitionWindowWithOptions (aWidget, kWindowSlideTransitionEffect, kWindowResizeTransitionAction, &r, false, NULL);
-}
-
+    int err = ::TransitionWindowWithOptions (aWidget,
+                                             kWindowSlideTransitionEffect,
+                                             kWindowResizeTransitionAction,
+                                             &r,
+                                             false,
+                                             NULL);
+    AssertCarbonOSStatus (err);
+}
 
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin-cocoa.m
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin-cocoa.m	(revision 17149)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin-cocoa.m	(revision 17150)
@@ -33,5 +33,5 @@
     if (aView)
         return [aView window];
-    return 0;
+    return NULL;
 }
 
@@ -39,4 +39,25 @@
 {
     [aWindow setShowsToolbarButton:aEnabled];
+}
+
+void darwinSetShowsResizeIndicatorImpl (NativeWindowRef aWindow, bool aEnabled)
+{
+    [aWindow setShowsResizeIndicator:aEnabled];
+}
+
+void darwinSetHidesAllTitleButtonsImpl (NativeWindowRef aWindow)
+{
+    NSButton *closeButton = [aWindow standardWindowButton:NSWindowCloseButton];
+    if (closeButton != Nil)
+        [closeButton setHidden:YES];
+    NSButton *minButton = [aWindow standardWindowButton:NSWindowMiniaturizeButton];
+    if (minButton != Nil)
+        [minButton setHidden:YES];
+    NSButton *zoomButton = [aWindow standardWindowButton:NSWindowZoomButton];
+    if (zoomButton != Nil)
+        [zoomButton setHidden:YES];
+    NSButton *iconButton = [aWindow standardWindowButton:NSWindowDocumentIconButton];
+    if (iconButton != Nil)
+        [iconButton setHidden:YES];
 }
 
@@ -68,2 +89,3 @@
     [aWindow setFrame:windowFrame display:YES animate:YES];
 }
+
Index: /trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin.cpp	(revision 17149)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/darwin/VBoxUtils-darwin.cpp	(revision 17150)
@@ -41,10 +41,10 @@
 NativeWindowRef darwinToNativeWindow (QWidget *aWidget)
 {
-    return darwinToNativeWindowImpl (::darwinToNativeView (aWidget));
+    return ::darwinToNativeWindowImpl (::darwinToNativeView (aWidget));
 }
 
 NativeWindowRef darwinToNativeWindow (NativeViewRef aView)
 {
-    return darwinToNativeWindowImpl (aView);
+    return ::darwinToNativeWindowImpl (aView);
 }
 
@@ -53,10 +53,25 @@
     QWidget *parent = aToolBar->parentWidget();
     if (parent)
-        darwinSetShowsToolbarButtonImpl (::darwinToNativeWindow (parent), aEnabled);
+        ::darwinSetShowsToolbarButtonImpl (::darwinToNativeWindow (parent), aEnabled);
 }
 
 void darwinWindowAnimateResize (QWidget *aWidget, const QRect &aTarget)
 {
-    darwinWindowAnimateResizeImpl (::darwinToNativeWindow (aWidget), aTarget.x(), aTarget.y(), aTarget.width(), aTarget.height());
+    ::darwinWindowAnimateResizeImpl (::darwinToNativeWindow (aWidget), aTarget.x(), aTarget.y(), aTarget.width(), aTarget.height());
+}
+
+void darwinSetHidesAllTitleButtons (QWidget *aWidget)
+{
+#ifdef QT_MAC_USE_COCOA
+    /* Currently only necessary in the Cocoa version */
+    ::darwinSetHidesAllTitleButtonsImpl (::darwinToNativeWindow (aWidget));
+#else /* QT_MAC_USE_COCOA */
+    NOREF (aWidget);
+#endif /* !QT_MAC_USE_COCOA */
+}
+
+void darwinSetShowsResizeIndicator (QWidget *aWidget, bool aEnabled)
+{
+    ::darwinSetShowsResizeIndicatorImpl (::darwinToNativeWindow (aWidget), aEnabled);
 }
 