Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxDownloaderWgt.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxDownloaderWgt.cpp	(revision 17150)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxDownloaderWgt.cpp	(revision 17160)
@@ -77,5 +77,5 @@
 
 /* This function is used to store content length */
-void VBoxDownloaderWgt::acknowledgeProcess (const QHttpResponseHeader &aResponse)
+void VBoxDownloaderWgt::acknowledgeProcess (const QHttpResponseHeader & /* aResponse */)
 {
     /* Abort connection as we already got all we need */
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 17150)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxGlobal.cpp	(revision 17160)
@@ -3893,5 +3893,5 @@
 /* static */
 QRect VBoxGlobal::getNormalized (const QRect &aRectangle, const QRegion &aBoundRegion,
-                                 bool aCanResize /* = true */)
+                                 bool /* aCanResize = true */)
 {
     /* Storing available horizontal sub-rectangles & vertical shifts */
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWgt.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWgt.cpp	(revision 17150)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxImportApplianceWgt.cpp	(revision 17160)
@@ -122,10 +122,10 @@
     int columnCount() const { return 3; }
 
-    virtual Qt::ItemFlags itemFlags (int aColumn) const { return 0; }
-    virtual bool setData (int aColumn, const QVariant &aValue, int aRole) { return false; }
-    virtual QVariant data (int aColumn, int aRole) const { return QVariant(); }
-    virtual QWidget * createEditor (QWidget *aParent, const QStyleOptionViewItem &aOption, const QModelIndex &aIndex) const { return NULL; }
-    virtual bool setEditorData (QWidget *aEditor, const QModelIndex &aIndex) const { return false; }
-    virtual bool setModelData (QWidget *aEditor, QAbstractItemModel *aModel, const QModelIndex &aIndex) { return false; }
+    virtual Qt::ItemFlags itemFlags (int /* aColumn */) const { return 0; }
+    virtual bool setData (int /* aColumn */, const QVariant & /* aValue */, int /* aRole */) { return false; }
+    virtual QVariant data (int /* aColumn */, int /* aRole */) const { return QVariant(); }
+    virtual QWidget * createEditor (QWidget * /* aParent */, const QStyleOptionViewItem & /* aOption */, const QModelIndex & /* aIndex */) const { return NULL; }
+    virtual bool setEditorData (QWidget * /* aEditor */, const QModelIndex & /* aIndex */) const { return false; }
+    virtual bool setModelData (QWidget * /* aEditor */, QAbstractItemModel * /* aModel */, const QModelIndex & /* aIndex */) { return false; }
 
     virtual void restoreDefaults() {}
@@ -381,5 +381,5 @@
     }
 
-    virtual QWidget * createEditor (QWidget *aParent, const QStyleOptionViewItem &aOption, const QModelIndex &aIndex) const
+    virtual QWidget * createEditor (QWidget *aParent, const QStyleOptionViewItem & /* aOption */, const QModelIndex &aIndex) const
     {
         QWidget *editor = NULL;
@@ -466,5 +466,5 @@
     }
 
-    virtual bool setEditorData (QWidget *aEditor, const QModelIndex &aIndex) const
+    virtual bool setEditorData (QWidget *aEditor, const QModelIndex & /* aIndex */) const
     {
         bool fDone = false;
@@ -541,5 +541,5 @@
     }
 
-    virtual bool setModelData (QWidget *aEditor, QAbstractItemModel *aModel, const QModelIndex &aIndex)
+    virtual bool setModelData (QWidget *aEditor, QAbstractItemModel * /* aModel */, const QModelIndex & /* aIndex */)
     {
         bool fDone = false;
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxRegistrationDlg.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxRegistrationDlg.cpp	(revision 17150)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxRegistrationDlg.cpp	(revision 17160)
@@ -196,5 +196,5 @@
 }
 
-VBoxRegistrationDlg::VBoxRegistrationDlg (VBoxRegistrationDlg **aSelf, QWidget *aParent)
+VBoxRegistrationDlg::VBoxRegistrationDlg (VBoxRegistrationDlg **aSelf, QWidget * /* aParent */)
     : QIWithRetranslateUI <QIAbstractWizard> (0)
     , mSelf (aSelf)
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 17150)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxSelectorWnd.cpp	(revision 17160)
@@ -1132,5 +1132,5 @@
     const QModelIndex &index = mVMListView->indexAt (aPoint);
     if (index.isValid())
-        if (VBoxVMItem *item = mVMListView->model()->data (index,
+        if (mVMListView->model()->data (index,
             VBoxVMModel::VBoxVMItemPtrRole).value <VBoxVMItem*>())
                 mVMCtxtMenu->exec (mVMListView->mapToGlobal (aPoint));
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsGeneral.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsGeneral.cpp	(revision 17150)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsGeneral.cpp	(revision 17160)
@@ -491,5 +491,5 @@
 }
 
-void VBoxVMSettingsGeneral::stateChangedVirt (int aState)
+void VBoxVMSettingsGeneral::stateChangedVirt (int /* aState */)
 {
     mCbNestedPaging->setEnabled (mCbVirt->checkState());