Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp	(revision 17176)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp	(revision 17192)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2008 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2009 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -3133,9 +3133,9 @@
 
     hostDVDMap.clear();
-    CHostDVDDriveEnumerator en =
-        vboxGlobal().virtualBox().GetHost().GetDVDDrives().Enumerate();
-    while (en.HasMore())
-    {
-        CHostDVDDrive hostDVD = en.GetNext();
+    CHostDVDDriveVector drvvec =
+        vboxGlobal().virtualBox().GetHost().GetDVDDrives();
+    for (int i = 0; i < drvvec.size(); ++i)
+    {
+        CHostDVDDrive hostDVD = drvvec[i];
         /** @todo set icon */
         QString drvName = hostDVD.GetName();
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMFirstRunWzd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMFirstRunWzd.cpp	(revision 17176)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMFirstRunWzd.cpp	(revision 17192)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2008 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2009 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -176,12 +176,11 @@
     {
         /* Search for the host dvd-drives */
-        CHostDVDDriveCollection coll =
+        CHostDVDDriveVector coll =
             vboxGlobal().virtualBox().GetHost().GetDVDDrives();
-        mHostDVDs.resize (coll.GetCount());
-        int id = 0;
-        CHostDVDDriveEnumerator en = coll.Enumerate();
-        while (en.HasMore())
-        {
-            CHostDVDDrive hostDVD = en.GetNext();
+        mHostDVDs.resize (coll.size());
+
+        for (int id = 0; id < coll.size(); ++id)
+        {
+            CHostDVDDrive hostDVD = coll[id];
             QString name = hostDVD.GetName();
             QString description = hostDVD.GetDescription();
@@ -190,5 +189,4 @@
             mCbHost->insertItem (id, fullName);
             mHostDVDs [id] = hostDVD;
-            ++ id;
         }
 
@@ -222,5 +220,5 @@
 
     /* Repopulate the media list */
-        mCbImage->repopulate();
+    mCbImage->repopulate();
 
     /* Revalidate updated page */
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsCD.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsCD.cpp	(revision 17176)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsCD.cpp	(revision 17192)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2008 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2009 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -59,13 +59,12 @@
 
     /* Read out the host DVD drive list and prepare the combobox */
-    CHostDVDDriveCollection coll =
+    CHostDVDDriveVector coll =
         vboxGlobal().virtualBox().GetHost().GetDVDDrives();
-    mHostCDs.resize (coll.GetCount());
+    mHostCDs.resize (coll.size());
     mCbHostCD->clear();
-    int id = 0;
-    CHostDVDDriveEnumerator en = coll.Enumerate();
-    while (en.HasMore())
-    {
-        CHostDVDDrive hostDVD = en.GetNext();
+
+    for (int id = 0; id < coll.size(); ++id)
+    {
+        CHostDVDDrive hostDVD = coll[id];
         /// @todo (r=dmik) set icon?
         QString name = hostDVD.GetName();
@@ -75,5 +74,4 @@
         mCbHostCD->insertItem (id, fullName);
         mHostCDs [id] = hostDVD;
-        ++ id;
     }
 
@@ -89,5 +87,5 @@
                 name :
                 QString ("%1 (%2)").arg (description, name);
-            if (coll.FindByName (name).isNull())
+            if (vboxGlobal().virtualBox().GetHost().FindHostDVDDrive (name).isNull())
             {
                 /* If the DVD drive is not currently available,