Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp	(revision 17217)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxConsoleWnd.cpp	(revision 17218)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2009 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2008 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -3064,9 +3064,9 @@
 
     hostDVDMap.clear();
-    CHostDVDDriveVector drvvec =
-        vboxGlobal().virtualBox().GetHost().GetDVDDrives();
-    for (int i = 0; i < drvvec.size(); ++i)
-    {
-        CHostDVDDrive hostDVD = drvvec[i];
+    CHostDVDDriveEnumerator en =
+        vboxGlobal().virtualBox().GetHost().GetDVDDrives().Enumerate();
+    while (en.HasMore())
+    {
+        CHostDVDDrive hostDVD = en.GetNext();
         /** @todo set icon */
         QString drvName = hostDVD.GetName();
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMFirstRunWzd.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMFirstRunWzd.cpp	(revision 17217)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMFirstRunWzd.cpp	(revision 17218)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2009 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2008 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -176,11 +176,12 @@
     {
         /* Search for the host dvd-drives */
-        CHostDVDDriveVector coll =
+        CHostDVDDriveCollection coll =
             vboxGlobal().virtualBox().GetHost().GetDVDDrives();
-        mHostDVDs.resize (coll.size());
-
-        for (int id = 0; id < coll.size(); ++id)
-        {
-            CHostDVDDrive hostDVD = coll[id];
+        mHostDVDs.resize (coll.GetCount());
+        int id = 0;
+        CHostDVDDriveEnumerator en = coll.Enumerate();
+        while (en.HasMore())
+        {
+            CHostDVDDrive hostDVD = en.GetNext();
             QString name = hostDVD.GetName();
             QString description = hostDVD.GetDescription();
@@ -189,4 +190,5 @@
             mCbHost->insertItem (id, fullName);
             mHostDVDs [id] = hostDVD;
+            ++ id;
         }
 
@@ -220,5 +222,5 @@
 
     /* Repopulate the media list */
-    mCbImage->repopulate();
+        mCbImage->repopulate();
 
     /* Revalidate updated page */
Index: trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsCD.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsCD.cpp	(revision 17217)
+++ trunk/src/VBox/Frontends/VirtualBox/src/VBoxVMSettingsCD.cpp	(revision 17218)
@@ -6,5 +6,5 @@
 
 /*
- * Copyright (C) 2006-2009 Sun Microsystems, Inc.
+ * Copyright (C) 2006-2008 Sun Microsystems, Inc.
  *
  * This file is part of VirtualBox Open Source Edition (OSE), as
@@ -59,12 +59,13 @@
 
     /* Read out the host DVD drive list and prepare the combobox */
-    CHostDVDDriveVector coll =
+    CHostDVDDriveCollection coll =
         vboxGlobal().virtualBox().GetHost().GetDVDDrives();
-    mHostCDs.resize (coll.size());
+    mHostCDs.resize (coll.GetCount());
     mCbHostCD->clear();
-
-    for (int id = 0; id < coll.size(); ++id)
-    {
-        CHostDVDDrive hostDVD = coll[id];
+    int id = 0;
+    CHostDVDDriveEnumerator en = coll.Enumerate();
+    while (en.HasMore())
+    {
+        CHostDVDDrive hostDVD = en.GetNext();
         /// @todo (r=dmik) set icon?
         QString name = hostDVD.GetName();
@@ -74,4 +75,5 @@
         mCbHostCD->insertItem (id, fullName);
         mHostCDs [id] = hostDVD;
+        ++ id;
     }
 
@@ -87,5 +89,5 @@
                 name :
                 QString ("%1 (%2)").arg (description, name);
-            if (vboxGlobal().virtualBox().GetHost().FindHostDVDDrive (name).isNull())
+            if (coll.FindByName (name).isNull())
             {
                 /* If the DVD drive is not currently available,