Index: /trunk/src/VBox/Additions/solaris/Installer/makepackage.sh
===================================================================
--- /trunk/src/VBox/Additions/solaris/Installer/makepackage.sh	(revision 17240)
+++ /trunk/src/VBox/Additions/solaris/Installer/makepackage.sh	(revision 17241)
@@ -82,8 +82,8 @@
 
 # 32-bit vboxvfs
-filelist_fixup prototype '$3 == "opt/VirtualBoxAdditions/vboxvfs=vboxvfs"'                  '$3 = "usr/kernel/fs/vboxvfs=vboxvfs"; $6="sys"'
+#filelist_fixup prototype '$3 == "opt/VirtualBoxAdditions/vboxvfs=vboxvfs"'                  '$3 = "usr/kernel/fs/vboxvfs=vboxvfs"; $6="sys"'
 
 # 64-bit vboxvfs
-filelist_fixup prototype '$3 == "opt/VirtualBoxAdditions/amd64/vboxvfs=amd64/vboxvfs"'      '$3 = "usr/kernel/fs/amd64/vboxvfs=amd64/vboxvfs"; $6="sys"'
+#filelist_fixup prototype '$3 == "opt/VirtualBoxAdditions/amd64/vboxvfs=amd64/vboxvfs"'      '$3 = "usr/kernel/fs/amd64/vboxvfs=amd64/vboxvfs"; $6="sys"'
 
 # vboxvfsmount binary (always 32-bit on combined package)
Index: /trunk/src/VBox/Additions/solaris/Installer/postinstall.sh
===================================================================
--- /trunk/src/VBox/Additions/solaris/Installer/postinstall.sh	(revision 17240)
+++ /trunk/src/VBox/Additions/solaris/Installer/postinstall.sh	(revision 17241)
@@ -66,7 +66,17 @@
 }
 
+solaris64dir="amd64"
 vboxadditions_path="/opt/VirtualBoxAdditions"
-vboxadditions64_path=$vboxadditions_path/amd64
-solaris64dir="amd64"
+vboxadditions64_path=$vboxadditions_path/$solaris64dir
+
+# get what ISA the guest is running 
+cputype=`isainfo -k` 
+if test "$cputype" = "amd64"; then 
+    isadir=$solaris64dir
+else
+    isadir="" 
+fi
+vboxadditionsisa_path=$vboxadditions_path/$isadir
+
 
 # uncompress if necessary
@@ -93,11 +103,4 @@
 /usr/sbin/devfsadm -i vboxguest
 sync
-
-# get what ISA the guest is running 
-cputype=`isainfo -k` 
-isadir="" 
-if test "$cputype" = "amd64"; then 
-    isadir="amd64" 
-fi
 
 # create links
@@ -216,4 +219,33 @@
 fi
 
+# Shared Folder kernel module (different for S10 & Nevada)
+osverstr=`uname -r`
+vboxvfsmod="vboxvfs"
+vboxvfsunused="vboxvfs_s10"
+if test "$osverstr" = "5.10"; then
+    vboxvfsmod="vboxvfs_s10"
+    vboxvfsunused="vboxvfs"
+fi
+
+# Move the appropriate module to kernel/fs & remove the unused module name from pkg and file from disk
+# 64-bit shared folder module
+if test -f "$vboxadditions64_path/$vboxvfsmod"; then
+    /usr/sbin/installf -c none $PKGINST "usr/kernel/fs/$solaris64dir/vboxvfs" f
+    mv -f $vboxadditions64_path/$vboxvfsmod /usr/kernel/fs/$solaris64dir/vboxvfs
+    /usr/sbin/removef $PKGINST $vboxadditions64_path/$vboxvfsmod 1>/dev/null
+    /usr/sbin/removef $PKGINST $vboxadditions64_path/$vboxvfsunused 1>/dev/null
+    rm -f $vboxadditions64_path/$vboxvfsunused
+fi
+
+# 32-bit shared folder module
+if test -f "$vboxadditions_path/$vboxvfsmod"; then
+    /usr/sbin/installf -c none $PKGINST "usr/kernel/fs/vboxvfs" f
+    mv -f $vboxadditions_path/$vboxvfsmod /usr/kernel/fs/vboxvfs
+    /usr/sbin/removef $PKGINST $vboxadditions_path/$vboxvfsmod 1>/dev/null
+    /usr/sbin/removef $PKGINST $vboxadditions_path/$vboxvfsunused 1>/dev/null
+    rm -f $vboxadditions_path/$vboxvfsunused
+fi
+
+
 # Finalize
 /usr/sbin/removef -f $PKGINST
Index: /trunk/src/VBox/Additions/solaris/Makefile.kmk
===================================================================
--- /trunk/src/VBox/Additions/solaris/Makefile.kmk	(revision 17240)
+++ /trunk/src/VBox/Additions/solaris/Makefile.kmk	(revision 17241)
@@ -62,4 +62,5 @@
 	$(SOLARIS_ADD_BIN_64)/vboxguest \
 	$(SOLARIS_ADD_BIN_64)/vboxvfs \
+	$(if $(VBOX_OSE),,$(SOLARIS_ADD_BIN_64)/vboxvfs_s10) \
 	$(SOLARIS_ADD_BIN_64)/VBoxClient \
 	$(SOLARIS_ADD_BIN_64)/VBoxService \
@@ -76,4 +77,5 @@
 	$(SOLARIS_ADD_BIN_32)/vboxguest \
 	$(SOLARIS_ADD_BIN_32)/vboxvfs \
+	$(if $(VBOX_OSE),,$(SOLARIS_ADD_BIN_32)/vboxvfs_s10) \
 	$(SOLARIS_ADD_BIN_32)/vboxvfsmount \
 	$(SOLARIS_ADD_BIN_32)/VBoxClient \
@@ -99,4 +101,5 @@
 	$(SOLARIS_ADD_BIN)/vboxguest \
 	$(SOLARIS_ADD_BIN)/vboxvfs \
+	$(if $(VBOX_OSE),,$(SOLARIS_ADD_BIN)/vboxvfs_s10) \
 	$(SOLARIS_ADD_BIN)/vboxvfsmount \
 	$(SOLARIS_ADD_BIN)/VBoxClient \
@@ -166,4 +169,5 @@
 	$(QUIET)$(INSTALL) -m 0644 $(SOLARIS_ADD_BIN_64)/vboxguest                                          $(SOLARIS_ADD_INST_DIR_64)/vboxguest
 	$(QUIET)$(INSTALL) -m 0644 $(SOLARIS_ADD_BIN_64)/vboxvfs                                            $(SOLARIS_ADD_INST_DIR_64)/vboxvfs
+	$(QUIET)$(if $(VBOX_OSE),,$(INSTALL) -m 0644 $(SOLARIS_ADD_BIN_64)/vboxvfs_s10                      $(SOLARIS_ADD_INST_DIR_64)/vboxvfs_s10)
 	$(QUIET)$(INSTALL) -s -m 0755 $(SOLARIS_ADD_BIN_64)/VBoxClient                                      $(SOLARIS_ADD_INST_DIR_64)/VBoxClient
 	$(QUIET)$(INSTALL) -s -m 0755 $(SOLARIS_ADD_BIN_64)/VBoxService                                     $(SOLARIS_ADD_INST_DIR_64)/VBoxService
@@ -182,4 +186,5 @@
 	$(QUIET)$(INSTALL) -m 0644 $(SOLARIS_ADD_BIN_32)/vboxguest                                          $(SOLARIS_ADD_INST_DIR_32)/vboxguest
 	$(QUIET)$(INSTALL) -m 0644 $(SOLARIS_ADD_BIN_32)/vboxvfs                                            $(SOLARIS_ADD_INST_DIR_32)/vboxvfs
+	$(QUIET)$(if $(VBOX_OSE),,$(INSTALL) -m 0644 $(SOLARIS_ADD_BIN_32)/vboxvfs_s10                      $(SOLARIS_ADD_INST_DIR_32)/vboxvfs_s10)
 	$(QUIET)$(INSTALL) -m 0755 $(SOLARIS_ADD_BIN_32)/vboxvfsmount                                       $(SOLARIS_ADD_INST_DIR_32)/vboxvfsmount
 	$(QUIET)$(INSTALL) -s -m 0755 $(SOLARIS_ADD_BIN_32)/VBoxClient                                      $(SOLARIS_ADD_INST_DIR_32)/VBoxClient
@@ -231,4 +236,5 @@
 	$(QUIET)$(INSTALL) -m 0644 $(SOLARIS_ADD_BIN)/vboxguest                                             $(SOLARIS_ADD_INST_DIR_ISA)/vboxguest
 	$(QUIET)$(INSTALL) -m 0644 $(SOLARIS_ADD_BIN)/vboxvfs                                               $(SOLARIS_ADD_INST_DIR_ISA)/vboxvfs
+	$(QUIET)$(INSTALL) -m 0644 $(SOLARIS_ADD_BIN)/vboxvfs_s10                                           $(SOLARIS_ADD_INST_DIR_ISA)/vboxvfs_s10
 	$(QUIET)$(INSTALL) -m 0755 $(SOLARIS_ADD_BIN)/vboxvfsmount                                          $(SOLARIS_ADD_INST_DIR_ISA)/vboxvfsmount
 	$(QUIET)$(INSTALL) -s -m 0755 $(SOLARIS_ADD_BIN)/VBoxClient                                         $(SOLARIS_ADD_INST_DIR_ISA)/VBoxClient