Index: /trunk/src/VBox/Frontends/VBoxManage/VBoxManageImport.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VBoxManage/VBoxManageImport.cpp	(revision 17290)
+++ /trunk/src/VBox/Frontends/VBoxManage/VBoxManageImport.cpp	(revision 17291)
@@ -207,12 +207,12 @@
                 com::SafeArray<VirtualSystemDescriptionType_T> retTypes;
                 com::SafeArray<BSTR> aRefs;
-                com::SafeArray<BSTR> aOrigValues;
-                com::SafeArray<BSTR> aConfigValues;
+                com::SafeArray<BSTR> aOvfValues;
+                com::SafeArray<BSTR> aVboxValues;
                 com::SafeArray<BSTR> aExtraConfigValues;
                 CHECK_ERROR_BREAK(aVirtualSystemDescriptions[i],
                                   GetDescription(ComSafeArrayAsOutParam(retTypes),
                                                  ComSafeArrayAsOutParam(aRefs),
-                                                 ComSafeArrayAsOutParam(aOrigValues),
-                                                 ComSafeArrayAsOutParam(aConfigValues),
+                                                 ComSafeArrayAsOutParam(aOvfValues),
+                                                 ComSafeArrayAsOutParam(aVboxValues),
                                                  ComSafeArrayAsOutParam(aExtraConfigValues)));
 
@@ -235,5 +235,5 @@
                     Utf8Str strOverride;
 
-                    Bstr bstrFinalValue = aConfigValues[a];
+                    Bstr bstrFinalValue = aVboxValues[a];
 
                     bool fIgnoreThis = mapIgnoresMapsPerVsys[i][a];
@@ -271,5 +271,5 @@
                         case VirtualSystemDescriptionType_CPU:
                             RTPrintf("%2d: Number of CPUs (ignored): %ls\n",
-                                     a, aConfigValues[a]);
+                                     a, aVboxValues[a]);
                         break;
 
@@ -300,5 +300,5 @@
                                 RTPrintf("%2d: IDE controller, type %ls -- disabled\n",
                                          a,
-                                         aConfigValues[a]);
+                                         aVboxValues[a]);
                                 aEnabled[a] = false;
                             }
@@ -307,5 +307,5 @@
                                          "\n    (disable with \"-vsys %d -ignore %d\")\n",
                                          a,
-                                         aConfigValues[a],
+                                         aVboxValues[a],
                                          i, a);
                         break;
@@ -316,5 +316,5 @@
                                 RTPrintf("%2d: SATA controller, type %ls -- disabled\n",
                                          a,
-                                         aConfigValues[a]);
+                                         aVboxValues[a]);
                                 aEnabled[a] = false;
                             }
@@ -323,5 +323,5 @@
                                         "\n    (disable with \"-vsys %d -ignore %d\")\n",
                                         a,
-                                        aConfigValues[a],
+                                        aVboxValues[a],
                                         i, a);
                         break;
@@ -332,5 +332,5 @@
                                 RTPrintf("%2d: SCSI controller, type %ls -- disabled\n",
                                          a,
-                                         aConfigValues[a]);
+                                         aVboxValues[a]);
                                 aEnabled[a] = false;
                             }
@@ -351,5 +351,5 @@
                                             "\n    disable with \"-vsys %d -ignore %d\")\n",
                                             a,
-                                            aConfigValues[a],
+                                            aVboxValues[a],
                                             i, a, i, a);
                             }
@@ -361,5 +361,5 @@
                                 RTPrintf("%2d: Hard disk image: source image=%ls -- disabled\n",
                                          a,
-                                         aOrigValues[a]);
+                                         aOvfValues[a]);
                                 aEnabled[a] = false;
                             }
@@ -376,6 +376,6 @@
                                     RTPrintf("%2d: Hard disk image: source image=%ls, target path=%ls, %ls\n",
                                             a,
-                                            aOrigValues[a],
-                                            aConfigValues[a],
+                                            aOvfValues[a],
+                                            aVboxValues[a],
                                             aExtraConfigValues[a]);
                                 }
@@ -385,6 +385,6 @@
                                             "\n    disable with \"-vsys %d -ignore %d\")\n",
                                             a,
-                                            aOrigValues[a],
-                                            aConfigValues[a],
+                                            aOvfValues[a],
+                                            aVboxValues[a],
                                             aExtraConfigValues[a],
                                             i, a, i, a);
@@ -421,6 +421,6 @@
                             RTPrintf("%2d: Network adapter: orig %ls, config %ls, extra %ls\n",   // @todo implement once we have a plan for the back-end
                                      a,
-                                     aOrigValues[a],
-                                     aConfigValues[a],
+                                     aOvfValues[a],
+                                     aVboxValues[a],
                                      aExtraConfigValues[a]);
                         break;
@@ -444,5 +444,5 @@
                                 RTPrintf("%2d: Sound card \"%ls\" -- disabled\n",
                                          a,
-                                         aOrigValues[a]);
+                                         aOvfValues[a]);
                                 aEnabled[a] = false;
                             }
@@ -451,5 +451,5 @@
                                         "\n    (disable with \"-vsys %d -ignore %d\")\n",
                                         a,
-                                        aOrigValues[a],
+                                        aOvfValues[a],
                                         i,
                                         a);
Index: /trunk/src/VBox/Main/ApplianceImpl.cpp
===================================================================
--- /trunk/src/VBox/Main/ApplianceImpl.cpp	(revision 17290)
+++ /trunk/src/VBox/Main/ApplianceImpl.cpp	(revision 17291)
@@ -1800,5 +1800,5 @@
                 throw setError(VBOX_E_FILE_ERROR,
                                tr("Missing guest OS type"));
-            const Utf8Str &strOsTypeVBox = vsdeOS.front()->strConfig;
+            const Utf8Str &strOsTypeVBox = vsdeOS.front()->strVbox;
 
             /* Now that we know the base system get our internal defaults based on that. */
@@ -1813,5 +1813,5 @@
                 throw setError(VBOX_E_FILE_ERROR,
                                tr("Missing VM name"));
-            const Utf8Str &strNameVBox = vsdeName.front()->strConfig;
+            const Utf8Str &strNameVBox = vsdeName.front()->strVbox;
             rc = pVirtualBox->CreateMachine(Bstr(strNameVBox), Bstr(strOsTypeVBox),
                                                  Bstr(), Guid(),
@@ -1828,5 +1828,5 @@
             std::list<VirtualSystemDescriptionEntry*> vsdeRAM = vsdescThis->findByType(VirtualSystemDescriptionType_Memory);
             ComAssertMsgThrow(vsdeRAM.size() == 1, ("RAM size missing"), E_FAIL);
-            const Utf8Str &memoryVBox = vsdeRAM.front()->strConfig;
+            const Utf8Str &memoryVBox = vsdeRAM.front()->strVbox;
             ULONG tt = (ULONG)RTStrToUInt64(memoryVBox.c_str());
             rc = pNewMachine->COMSETTER(MemorySize)(tt);
@@ -1851,5 +1851,5 @@
             if (vsdeAudioAdapter.size() > 0)
             {
-                const Utf8Str& audioAdapterVBox = vsdeAudioAdapter.front()->strConfig;
+                const Utf8Str& audioAdapterVBox = vsdeAudioAdapter.front()->strVbox;
                 if (RTStrICmp(audioAdapterVBox, "null") != 0)
                 {
@@ -1903,5 +1903,5 @@
                      ++nwIt, ++a)
                 {
-                    const Utf8Str &nwTypeVBox = (*nwIt)->strConfig;
+                    const Utf8Str &nwTypeVBox = (*nwIt)->strVbox;
                     uint32_t tt1 = RTStrToUInt32(nwTypeVBox.c_str());
                     ComPtr<INetworkAdapter> nwVBox;
@@ -1945,5 +1945,5 @@
                 if (FAILED(rc)) throw rc;
 
-                const char *pcszIDEType = vsdeHDCIDE.front()->strConfig.c_str();
+                const char *pcszIDEType = vsdeHDCIDE.front()->strVbox.c_str();
                 if (!strcmp(pcszIDEType, "PIIX3"))
                     rc = biosSettings->COMSETTER(IDEControllerType)(IDEControllerType_PIIX3);
@@ -1964,5 +1964,5 @@
             if (vsdeHDCSATA.size() > 0)
             {
-                const Utf8Str &hdcVBox = vsdeHDCIDE.front()->strConfig;
+                const Utf8Str &hdcVBox = vsdeHDCIDE.front()->strVbox;
                 if (hdcVBox == "AHCI")
                 {
@@ -2034,5 +2034,5 @@
                         VirtualSystemDescriptionEntry *vsdeHD = *itHD;
 
-                        const char *pcszDstFilePath = vsdeHD->strConfig.c_str();
+                        const char *pcszDstFilePath = vsdeHD->strVbox.c_str();
                         /* Check if the destination file exists already or the
                          * destination path is empty. */
@@ -2413,5 +2413,5 @@
                                                       ComSafeArrayOut(BSTR, aRefs),
                                                       ComSafeArrayOut(BSTR, aOrigValues),
-                                                      ComSafeArrayOut(BSTR, aConfigValues),
+                                                      ComSafeArrayOut(BSTR, aVboxValues),
                                                       ComSafeArrayOut(BSTR, aExtraConfigValues))
 {
@@ -2419,5 +2419,5 @@
         ComSafeArrayOutIsNull(aRefs) ||
         ComSafeArrayOutIsNull(aOrigValues) ||
-        ComSafeArrayOutIsNull(aConfigValues) ||
+        ComSafeArrayOutIsNull(aVboxValues) ||
         ComSafeArrayOutIsNull(aExtraConfigValues))
         return E_POINTER;
@@ -2432,5 +2432,5 @@
     com::SafeArray<BSTR> sfaRefs(c);
     com::SafeArray<BSTR> sfaOrigValues(c);
-    com::SafeArray<BSTR> sfaConfigValues(c);
+    com::SafeArray<BSTR> sfaVboxValues(c);
     com::SafeArray<BSTR> sfaExtraConfigValues(c);
 
@@ -2448,9 +2448,9 @@
         bstr.cloneTo(&sfaRefs[i]);
 
-        bstr = vsde.strOrig;
+        bstr = vsde.strOvf;
         bstr.cloneTo(&sfaOrigValues[i]);
 
-        bstr = vsde.strConfig;
-        bstr.cloneTo(&sfaConfigValues[i]);
+        bstr = vsde.strVbox;
+        bstr.cloneTo(&sfaVboxValues[i]);
 
         bstr = vsde.strExtraConfig;
@@ -2461,5 +2461,5 @@
     sfaRefs.detachTo(ComSafeArrayOutArg(aRefs));
     sfaOrigValues.detachTo(ComSafeArrayOutArg(aOrigValues));
-    sfaConfigValues.detachTo(ComSafeArrayOutArg(aConfigValues));
+    sfaVboxValues.detachTo(ComSafeArrayOutArg(aVboxValues));
     sfaExtraConfigValues.detachTo(ComSafeArrayOutArg(aExtraConfigValues));
 
@@ -2472,8 +2472,8 @@
  */
 STDMETHODIMP VirtualSystemDescription::SetFinalValues(ComSafeArrayIn(BOOL, aEnabled),
-                                                      ComSafeArrayIn(IN_BSTR, argConfigValues),
+                                                      ComSafeArrayIn(IN_BSTR, argVboxValues),
                                                       ComSafeArrayIn(IN_BSTR, argExtraConfigValues))
 {
-    CheckComArgSafeArrayNotNull(argConfigValues);
+    CheckComArgSafeArrayNotNull(argVboxValues);
     CheckComArgSafeArrayNotNull(argExtraConfigValues);
 
@@ -2483,8 +2483,8 @@
     AutoWriteLock alock(this);
 
-    com::SafeArray<IN_BSTR> aConfigValues(ComSafeArrayInArg(argConfigValues));
+    com::SafeArray<IN_BSTR> aVboxValues(ComSafeArrayInArg(argVboxValues));
     com::SafeArray<IN_BSTR> aExtraConfigValues(ComSafeArrayInArg(argExtraConfigValues));
 
-    if (    (aConfigValues.size() != m->descriptions.size())
+    if (    (aVboxValues.size() != m->descriptions.size())
          || (aExtraConfigValues.size() != m->descriptions.size())
        )
@@ -2501,5 +2501,5 @@
         if (aEnabled[i])
         {
-            vsde.strConfig = aConfigValues[i];
+            vsde.strVbox = aVboxValues[i];
             vsde.strExtraConfig = aExtraConfigValues[i];
         }
@@ -2560,6 +2560,6 @@
     vsde.type = aType;
     vsde.strRef = strRef;
-    vsde.strOrig = aOrigValue;
-    vsde.strConfig = aAutoValue;
+    vsde.strOvf = aOrigValue;
+    vsde.strVbox = aAutoValue;
     vsde.strExtraConfig = strExtraConfig;
 
@@ -2744,5 +2744,5 @@
         ComPtr<IBIOSSettings> pBiosSettings;
         pBiosSettings = mBIOSSettings;
-        Utf8Str strConfig;
+        Utf8Str strVbox;
         IDEControllerType_T ctlr;
         rc = pBiosSettings->COMGETTER(IDEControllerType)(&ctlr);
@@ -2750,13 +2750,13 @@
         switch(ctlr)
         {
-            case IDEControllerType_PIIX3: strConfig = "PIIX3"; break;
-            case IDEControllerType_PIIX4: strConfig = "PIIX4"; break;
-            case IDEControllerType_ICH6: strConfig = "ICH6"; break;
+            case IDEControllerType_PIIX3: strVbox = "PIIX3"; break;
+            case IDEControllerType_PIIX4: strVbox = "PIIX4"; break;
+            case IDEControllerType_ICH6: strVbox = "ICH6"; break;
         }
 
-        if (strConfig.length())
+        if (strVbox.length())
         {
             strIdeControllerID = Utf8StrFmt("%RI32", uControllerId++);
-            pNewDesc->addEntry(VirtualSystemDescriptionType_HardDiskControllerIDE, strIdeControllerID, strConfig, "");
+            pNewDesc->addEntry(VirtualSystemDescriptionType_HardDiskControllerIDE, strIdeControllerID, strVbox, "");
         }
 
@@ -2771,5 +2771,5 @@
         {
             strSataControllerID = Utf8StrFmt("%RI32", uControllerId++);
-            pNewDesc->addEntry(VirtualSystemDescriptionType_HardDiskControllerSATA, strSataControllerID, strConfig, "");
+            pNewDesc->addEntry(VirtualSystemDescriptionType_HardDiskControllerSATA, strSataControllerID, strVbox, "");
         }
 #endif // VBOX_WITH_AHCI
@@ -2806,6 +2806,9 @@
             if (FAILED(rc)) throw rc;
 
+            Bstr bstrName;
+            rc = pHardDisk->COMGETTER(Name)(bstrName.asOutParam());
+
             pNewDesc->addEntry(VirtualSystemDescriptionType_HardDiskImage,
-                               "", // hd.strDiskId,
+                               Utf8Str(bstrName), // hd.strDiskId,
                                "", // di.strHref,
                                "",
Index: /trunk/src/VBox/Main/idl/VirtualBox.xidl
===================================================================
--- /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 17290)
+++ /trunk/src/VBox/Main/idl/VirtualBox.xidl	(revision 17291)
@@ -3102,5 +3102,5 @@
       <link to="VirtualSystemDescriptionType" /> enum value in the array item in aTypes[]. In each case,
       the array item with the same index in aOrigValue[] will contain the original value as contained
-      in the OVF file (just for informational purposes), and the corresponding item in aConfigValues[]
+      in the OVF file (just for informational purposes), and the corresponding item in aVboxValues[]
       will contain a suggested value to be used for VirtualBox. Depending on the description type,
       the aExtraConfigValues[] array item may also be used.
@@ -3109,7 +3109,7 @@
       <li>
         "OS": the guest operating system type. There must be exactly one such array item on import. The
-        corresponding item in aConfigValues[] contains the suggested guest operating system for VirtualBox.
+        corresponding item in aVboxValues[] contains the suggested guest operating system for VirtualBox.
         This will be one of the values listed in <link to="IVirtualBox::guestOSTypes" />. The corresponding
-        item in aOrigValues[] will contain a numerical value that described the operating system in the OVF
+        item in aOvfValues[] will contain a numerical value that described the operating system in the OVF
         (see <link to="CIMOSType" />).
       </li>
@@ -3117,6 +3117,6 @@
         "Name": the name to give to the new virtual machine. There can be at most one such array item;
         if none is present on import, then an automatic name will be created from the operating system
-        type. The correponding item im aOrigValues[] will contain the suggested virtual machine name
-        from the OVF file, and aConfigValues[] will contain a suggestion for a unique VirtualBox
+        type. The correponding item im aOvfValues[] will contain the suggested virtual machine name
+        from the OVF file, and aVboxValues[] will contain a suggestion for a unique VirtualBox
         <link to="IMachine" /> name that does not exist yet.
       </li>
@@ -3131,5 +3131,5 @@
       <li>
         "HarddiskControllerIDE": an IDE hard disk controller. There can be at most one such item. This
-        has no value in aOrigValues[] or aConfigValues[].
+        has no value in aOvfValues[] or aVboxValues[].
         The matching item in the aRefs[] array will contain an integer that items of the "Harddisk"
         type can use to specify which hard disk controller a virtual disk should be connected to.
@@ -3137,18 +3137,22 @@
       <li>
         "HarddiskControllerSATA": an SATA hard disk controller. There can be at most one such item. This
-        has no value in aOrigValues[] or aConfigValues[].
+        has no value in aOvfValues[] or aVboxValues[].
         The matching item in the aRefs[] array will be used as with IDE controllers (see above).
       </li>
       <li>
         "HarddiskControllerSCSI": a SCSI hard disk controller. There can be at most one such item.
-        The items in aOrigValues[] and aConfigValues[] will either be "LsiLogic" or "BusLogic".
+        The items in aOvfValues[] and aVboxValues[] will either be "LsiLogic" or "BusLogic".
         The matching item in the aRefs[] array will be used as with IDE controllers (see above).
       </li>
       <li>
         "HardDiskImage": a virtual hard disk, most probably as a reference to an image file. There can be an
-        arbitrary number of these items, one for each virtual disk image that accompanies the OVF. The
-        array item in aOrigValues[] will contain the file specification from the OVF file, whereas the
-        item in aConfigValues[] will contain a qualified path specification to where the hard disk image
-        should be copied; this target image will then be registered with VirtualBox.
+        arbitrary number of these items, one for each virtual disk image that accompanies the OVF.
+
+        The array item in aOvfValues[] will contain the file specification from the OVF file,
+        whereas the item in aVboxValues[] will contain a qualified path specification to where
+        VirtualBox uses the hard disk image. This means that on import the image will be copied
+        and converted from the "ovf" location to the "vbox" location; on export, this will be
+        handled the other way round. On import, the target image will also be registered with VirtualBox.
+
         The matching item in the aExtraConfigValues[] array must contain a string of the following
         format: "controller=&lt;index&gt;;channel=&lt;c&gt;"
@@ -3169,5 +3173,5 @@
       </li>
       <li>
-        "NetworkAdapter": a network adapter. The array item in aConfigValues[] will specify the hardware
+        "NetworkAdapter": a network adapter. The array item in aVboxValues[] will specify the hardware
         for the network adapter, whereas the array item in aExtraConfigValues[] will have a string
         of the "network=&lt;nw&gt;" format, where &lt;nw&gt; must be one of the networks as specified with the
@@ -3192,9 +3196,9 @@
       </param>
 
-      <param name="aOrigValues" type="wstring" dir="out" safearray="yes">
+      <param name="aOvfValues" type="wstring" dir="out" safearray="yes">
         <desc></desc>
       </param>
 
-      <param name="aConfigValues" type="wstring" dir="out" safearray="yes">
+      <param name="aVboxValues" type="wstring" dir="out" safearray="yes">
         <desc></desc>
       </param>
@@ -3218,6 +3222,6 @@
         and SoundCard.
 
-        For the configuration and "extra" configuration values, if you pass in the same arrays
-        as returned in the aConfigValues and aExtraConfigValues arrays from getDescription(),
+        For the "vbox" and "extra configuration" values, if you pass in the same arrays
+        as returned in the aVboxValues and aExtraConfigValues arrays from getDescription(),
         the configuration remains unchanged. Please see the documentation for getDescription()
         for valid configuration values for the individual array item types. If the
@@ -3229,5 +3233,5 @@
       </param>
 
-      <param name="aConfigValues" type="wstring" dir="in" safearray="yes">
+      <param name="aVboxValues" type="wstring" dir="in" safearray="yes">
         <desc></desc>
       </param>
Index: /trunk/src/VBox/Main/include/ApplianceImpl.h
===================================================================
--- /trunk/src/VBox/Main/include/ApplianceImpl.h	(revision 17290)
+++ /trunk/src/VBox/Main/include/ApplianceImpl.h	(revision 17291)
@@ -110,6 +110,6 @@
     VirtualSystemDescriptionType_T type;    // type of this entry
     Utf8Str strRef;                         // reference number (hard disk controllers only)
-    Utf8Str strOrig;                        // original OVF value (type-dependent)
-    Utf8Str strConfig;                      // configuration value (type-dependent)
+    Utf8Str strOvf;                         // original OVF value (type-dependent)
+    Utf8Str strVbox;                        // configuration value (type-dependent)
     Utf8Str strExtraConfig;                 // extra configuration key=value strings (type-dependent)
 };
@@ -154,10 +154,10 @@
     STDMETHOD(GetDescription)(ComSafeArrayOut(VirtualSystemDescriptionType_T, aTypes),
                               ComSafeArrayOut(BSTR, aRefs),
-                              ComSafeArrayOut(BSTR, aOrigValues),
-                              ComSafeArrayOut(BSTR, aConfigValues),
+                              ComSafeArrayOut(BSTR, aOvfValues),
+                              ComSafeArrayOut(BSTR, aVboxValues),
                               ComSafeArrayOut(BSTR, aExtraConfigValues));
 
     STDMETHOD(SetFinalValues)(ComSafeArrayIn(BOOL, aEnabled),
-                              ComSafeArrayIn(IN_BSTR, aConfigValues),
+                              ComSafeArrayIn(IN_BSTR, aVboxValues),
                               ComSafeArrayIn(IN_BSTR, aExtraConfigValues));
 